function [AverageofAll,StdOfAll,StdOfMeans,MeanOfStds,StdOfStds,MaxMean,MaxMean_Std,MinMean,MinMean_Std,MaxStd,MaxStd_Mean,MinStd,MinStd_Mean]=Evaluation_First9SequentialPartition_for_YouTube(FileDir,DistanceMatrixFileName,CategoriesFileName)

load([FileDir,'/',DistanceMatrixFileName]);

load([FileDir,'/',CategoriesFileName]);


CorrectAnswer=[];
for i=1:length(Categories.Subject_Sets)
    CorrectAnswer=[CorrectAnswer i*ones(1,6)];
end

if exist('RandomSeed.mat','file')
    load('RandomSeed.mat');
    rng(random_seed);
else
    rng(1,'twister');
    random_seed = rng;
    save('RandomSeed.mat','random_seed');
    %to repeat, use 
    % load('RandomedResults\RandomSeed.mat');
    % rng(random_seed);
end

%Partition into 5 groups

for i=1:47
    if length(Categories.Subject_Sets{i})<45
        ParIndex(1:5)=round(linspace(0,length(Categories.Subject_Sets{i})-9,5));
        ParIndex(6)=length(Categories.Subject_Sets{i});
        for k=1:5
            group{i,k}=Categories.Subject_Sets{i}(ParIndex(k)+1:ParIndex(k)+9);
        end
    else
        ParIndex(1:6)=round(linspace(0,length(Categories.Subject_Sets{i}),6));
        for k=1:5
            group{i,k}=Categories.Subject_Sets{i}(ParIndex(k)+1:ParIndex(k)+9);  %ParIndex(k+1));
        end
    end
end



%%Now We do 1000 times of such experiments
X=zeros(1000,5);

for roundID=1:1000
    for k=1:5  %The k-th Set of Train&Test
        TrainIdx=zeros(1,47*3);
        TestIdx=zeros(1,47*6);
        for j=1:47
            pool=group{j,k};
            RandomizeTheSet=randperm(length(pool));
            TrainIdx(1,3*(j-1)+1:3*j)=pool(RandomizeTheSet(1:3));      
            TestIdx(1,6*(j-1)+1:6*j)=pool(RandomizeTheSet(4:9));
        end

        DMT=DM(TrainIdx,TestIdx);
        [~,MyAnswer]=min(DMT,[],1);
        
        MyAnswerId=ceil(MyAnswer/3);
        
        CorrectNumers=sum(MyAnswerId==CorrectAnswer);
        X(roundID,k)=CorrectNumers/(length(TestIdx));
    end
end
Means=mean(X,2);
Stds=std(X,1,2);
AverageofAll=mean(Means,1);
StdOfAll=std(reshape(X,[],1),1,1);
StdOfMeans=std(Means,1,1);
StdOfStds=std(Stds,1,1);
[MaxMean,idx]=max(Means,[],1);
[Idx,~]=find(Means>=MaxMean);
MaxMean_Std=min(Stds(Idx));
%if max(Stds(Idx))>min(Stds(Idx))
%    DistanceMatrixFileName
%    an=2
%end

[MinMean,idx]=min(Means,[],1);
[Idx,~]=find(Means<=MinMean);
MinMean_Std=max(Stds(Idx));
%if max(Stds(Idx))>min(Stds(Idx))
%    DistanceMatrixFileName
%    bn=2
%end

[MaxStd,idx]=max(Stds,[],1);
[Idx,~]=find(Stds>=MaxStd);
MaxStd_Mean=min(Means(Idx));

[MinStd,idx]=min(Stds,[],1);
[Idx,~]=find(Stds<=MinStd);
MinStd_Mean=max(Means(Idx));

MeanOfStds=mean(Stds,1);

end


